import { Maybe, MaybePromise, DeepDict, BasicDict } from '../types';
import { LoggerTransportConfig } from '../logger';
export declare enum Env {
    Production = "production",
    Development = "development",
    Testing = "test"
}
export type AppConfigLeaf = BasicDict;
export type AppConfig = {
    env: Env;
    censorSecrets: boolean;
    rootDir: string;
    logger?: LoggerTransportConfig;
} & BasicDict;
export type ConfigLoader = (...args: any[]) => ConfigLoaderOutput;
export type ConfigLoaderOutput = MaybePromise<Maybe<AppConfigLeaf>>;
export type ConfigConfigLeaf = ConfigLoaderOutput | ConfigLoaderOutput[] | AppConfig;
export type ConfigConfig = DeepDict<ConfigConfigLeaf> | ConfigConfigLeaf[];
export declare const mergeByPriority: <Leaf>(configArray: DeepDict<Leaf>[]) => DeepDict<Leaf>;
