import fp from 'lodash/fp';
import * as types from './types';
export type AsyncTransform<X, Y> = (x: X) => Promise<Y>;
export type Transform<X, Y> = (x: X) => Y;
export type MaybeAsyncTransform<X, Y> = AsyncTransform<X, Y> | Transform<X, Y>;
export type Cb<X> = (x: X) => Promise<any> | any;
export declare const cpipe: fp.LodashFlow;
export declare const pipe: <X, Y>(input: AsyncGenerator<X, any, unknown>, ...chain: Function[]) => Y;
export declare const filter: <X>(f: MaybeAsyncTransform<X, boolean>) => (iterator: AsyncGenerator<X, any, unknown>) => AsyncGenerator<X, any, unknown>;
export declare const map: <X, Y>(f: MaybeAsyncTransform<X, Y>) => (iterator: AsyncGenerator<X, any, unknown>) => AsyncGenerator<Y, any, unknown>;
export declare const probe: <X>(f: Cb<X>) => (iterator: AsyncGenerator<X, any, unknown>) => AsyncGenerator<X, any, unknown>;
export declare const window: <X>(n: number) => (iterator: AsyncGenerator<X, any, unknown>) => AsyncGenerator<X[], any, unknown>;
export declare function sequence(start: number, end: number): AsyncGenerator<number>;
export declare const delay: <X>(delayTime?: number) => (iterator: AsyncGenerator<X, any, unknown>) => AsyncGenerator<X, any, unknown>;
export declare const skip: <PAYLOAD>(start: number) => (node: AsyncGenerator<PAYLOAD, any, unknown>) => AsyncGenerator<Awaited<PAYLOAD>, void, unknown>;
export declare const limit: <PAYLOAD>(end: number) => (node: AsyncGenerator<PAYLOAD, any, unknown>) => AsyncGenerator<Awaited<PAYLOAD>, void, unknown>;
export declare const slice: (start?: number, end?: number) => (node: AsyncGenerator<unknown, any, unknown>) => AsyncGenerator<unknown, void, unknown>;
export declare const pullCount: () => <PAYLOAD>(node: AsyncGenerator<PAYLOAD, any, unknown>) => Promise<number>;
export declare const pullAll: () => <PAYLOAD>(node: AsyncGenerator<PAYLOAD, any, unknown>) => Promise<void>;
export declare const pullArray: () => <PAYLOAD>(node: AsyncGenerator<PAYLOAD, any, unknown>) => Promise<PAYLOAD[]>;
export declare const pull: (x?: number) => <PAYLOAD>(node: AsyncGenerator<PAYLOAD, any, unknown>) => Promise<void>;
export declare const catchLast: <PAYLOAD>(cb: MaybeAsyncTransform<void | PAYLOAD, any>) => (node: AsyncGenerator<PAYLOAD, any, unknown>) => AsyncGenerator<Awaited<PAYLOAD>, any, unknown>;
export declare const lifo: <PAYLOAD>() => types.BufferStore<PAYLOAD>;
export declare const fifo: <PAYLOAD>() => types.BufferStore<PAYLOAD>;
type BindBuffer<PAYLOAD> = (cb: (event: PAYLOAD) => any) => any;
export declare const buffer: <PAYLOAD>(store: types.BufferStore<PAYLOAD>) => (bindBuffer: BindBuffer<PAYLOAD>) => AsyncGenerator<PAYLOAD, any, unknown>;
export declare const bufferFifo: (bindBuffer: BindBuffer<unknown>) => AsyncGenerator<unknown, any, unknown>;
export declare const bufferLifo: (bindBuffer: BindBuffer<unknown>) => AsyncGenerator<unknown, any, unknown>;
export type Selector = (msg: any) => string;
export declare const by: <X>(selector: Selector) => (iterator: AsyncGenerator<X, any, unknown>) => AsyncGenerator<AsyncGenerator<X, any, unknown>, any, unknown>;
export type IteratorCallback<X, Y> = (streamName: string) => (input: AsyncGenerator<X>) => AsyncGenerator<Y>;
export type MetaIterator<X> = AsyncGenerator<AsyncGenerator<X>>;
export declare const split: <IN, OUT>(selector: Selector, iteratorCallback: IteratorCallback<IN, OUT>) => (iterator: AsyncGenerator<IN, any, unknown>) => AsyncGenerator<OUT, any, unknown>;
export declare const collect: <X>(metaIterator: AsyncGenerator<AsyncGenerator<X, any, unknown>, any, unknown>) => AsyncGenerator<X, any, unknown>;
export {};
