'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var path = require('path');
var Ajv = require('ajv');
var os = require('os');
var lodash = require('lodash');
var pino = require('pino');
var fp = require('lodash/fp');
var util = require('util');
var fs = require('fs');
var child_process = require('child_process');

function _interopNamespaceDefault(e) {
  var n = Object.create(null);
  if (e) {
    Object.keys(e).forEach(function (k) {
      if (k !== 'default') {
        var d = Object.getOwnPropertyDescriptor(e, k);
        Object.defineProperty(n, k, d.get ? d : {
          enumerable: true,
          get: function () { return e[k]; }
        });
      }
    });
  }
  n.default = e;
  return n;
}

var path__namespace = /*#__PURE__*/_interopNamespaceDefault(path);
var util__namespace = /*#__PURE__*/_interopNamespaceDefault(util);
var fs__namespace = /*#__PURE__*/_interopNamespaceDefault(fs);

var types = {
  __proto__: null
};

function _AsyncGenerator(gen) {
  var front, back;
  function resume(key, arg) {
    try {
      var result = gen[key](arg),
        value = result.value,
        overloaded = value instanceof _OverloadYield;
      Promise.resolve(overloaded ? value.v : value).then(function (arg) {
        if (overloaded) {
          var nextKey = "return" === key ? "return" : "next";
          if (!value.k || arg.done) return resume(nextKey, arg);
          arg = gen[nextKey](arg).value;
        }
        settle(result.done ? "return" : "normal", arg);
      }, function (err) {
        resume("throw", err);
      });
    } catch (err) {
      settle("throw", err);
    }
  }
  function settle(type, value) {
    switch (type) {
      case "return":
        front.resolve({
          value: value,
          done: !0
        });
        break;
      case "throw":
        front.reject(value);
        break;
      default:
        front.resolve({
          value: value,
          done: !1
        });
    }
    (front = front.next) ? resume(front.key, front.arg) : back = null;
  }
  this._invoke = function (key, arg) {
    return new Promise(function (resolve, reject) {
      var request = {
        key: key,
        arg: arg,
        resolve: resolve,
        reject: reject,
        next: null
      };
      back ? back = back.next = request : (front = back = request, resume(key, arg));
    });
  }, "function" != typeof gen.return && (this.return = void 0);
}
_AsyncGenerator.prototype["function" == typeof Symbol && Symbol.asyncIterator || "@@asyncIterator"] = function () {
  return this;
}, _AsyncGenerator.prototype.next = function (arg) {
  return this._invoke("next", arg);
}, _AsyncGenerator.prototype.throw = function (arg) {
  return this._invoke("throw", arg);
}, _AsyncGenerator.prototype.return = function (arg) {
  return this._invoke("return", arg);
};
function _OverloadYield(value, kind) {
  this.v = value, this.k = kind;
}
function _asyncIterator(iterable) {
  var method,
    async,
    sync,
    retry = 2;
  for ("undefined" != typeof Symbol && (async = Symbol.asyncIterator, sync = Symbol.iterator); retry--;) {
    if (async && null != (method = iterable[async])) return method.call(iterable);
    if (sync && null != (method = iterable[sync])) return new AsyncFromSyncIterator(method.call(iterable));
    async = "@@asyncIterator", sync = "@@iterator";
  }
  throw new TypeError("Object is not async iterable");
}
function AsyncFromSyncIterator(s) {
  function AsyncFromSyncIteratorContinuation(r) {
    if (Object(r) !== r) return Promise.reject(new TypeError(r + " is not an object."));
    var done = r.done;
    return Promise.resolve(r.value).then(function (value) {
      return {
        value: value,
        done: done
      };
    });
  }
  return AsyncFromSyncIterator = function (s) {
    this.s = s, this.n = s.next;
  }, AsyncFromSyncIterator.prototype = {
    s: null,
    n: null,
    next: function () {
      return AsyncFromSyncIteratorContinuation(this.n.apply(this.s, arguments));
    },
    return: function (value) {
      var ret = this.s.return;
      return void 0 === ret ? Promise.resolve({
        value: value,
        done: !0
      }) : AsyncFromSyncIteratorContinuation(ret.apply(this.s, arguments));
    },
    throw: function (value) {
      var thr = this.s.return;
      return void 0 === thr ? Promise.reject(value) : AsyncFromSyncIteratorContinuation(thr.apply(this.s, arguments));
    }
  }, new AsyncFromSyncIterator(s);
}
function _awaitAsyncGenerator(value) {
  return new _OverloadYield(value, 0);
}
function _regeneratorRuntime() {
  _regeneratorRuntime = function () {
    return exports;
  };
  var exports = {},
    Op = Object.prototype,
    hasOwn = Op.hasOwnProperty,
    defineProperty = Object.defineProperty || function (obj, key, desc) {
      obj[key] = desc.value;
    },
    $Symbol = "function" == typeof Symbol ? Symbol : {},
    iteratorSymbol = $Symbol.iterator || "@@iterator",
    asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator",
    toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";
  function define(obj, key, value) {
    return Object.defineProperty(obj, key, {
      value: value,
      enumerable: !0,
      configurable: !0,
      writable: !0
    }), obj[key];
  }
  try {
    define({}, "");
  } catch (err) {
    define = function (obj, key, value) {
      return obj[key] = value;
    };
  }
  function wrap(innerFn, outerFn, self, tryLocsList) {
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator,
      generator = Object.create(protoGenerator.prototype),
      context = new Context(tryLocsList || []);
    return defineProperty(generator, "_invoke", {
      value: makeInvokeMethod(innerFn, self, context)
    }), generator;
  }
  function tryCatch(fn, obj, arg) {
    try {
      return {
        type: "normal",
        arg: fn.call(obj, arg)
      };
    } catch (err) {
      return {
        type: "throw",
        arg: err
      };
    }
  }
  exports.wrap = wrap;
  var ContinueSentinel = {};
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}
  var IteratorPrototype = {};
  define(IteratorPrototype, iteratorSymbol, function () {
    return this;
  });
  var getProto = Object.getPrototypeOf,
    NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype);
  var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);
  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function (method) {
      define(prototype, method, function (arg) {
        return this._invoke(method, arg);
      });
    });
  }
  function AsyncIterator(generator, PromiseImpl) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);
      if ("throw" !== record.type) {
        var result = record.arg,
          value = result.value;
        return value && "object" == typeof value && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) {
          invoke("next", value, resolve, reject);
        }, function (err) {
          invoke("throw", err, resolve, reject);
        }) : PromiseImpl.resolve(value).then(function (unwrapped) {
          result.value = unwrapped, resolve(result);
        }, function (error) {
          return invoke("throw", error, resolve, reject);
        });
      }
      reject(record.arg);
    }
    var previousPromise;
    defineProperty(this, "_invoke", {
      value: function (method, arg) {
        function callInvokeWithMethodAndArg() {
          return new PromiseImpl(function (resolve, reject) {
            invoke(method, arg, resolve, reject);
          });
        }
        return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
      }
    });
  }
  function makeInvokeMethod(innerFn, self, context) {
    var state = "suspendedStart";
    return function (method, arg) {
      if ("executing" === state) throw new Error("Generator is already running");
      if ("completed" === state) {
        if ("throw" === method) throw arg;
        return doneResult();
      }
      for (context.method = method, context.arg = arg;;) {
        var delegate = context.delegate;
        if (delegate) {
          var delegateResult = maybeInvokeDelegate(delegate, context);
          if (delegateResult) {
            if (delegateResult === ContinueSentinel) continue;
            return delegateResult;
          }
        }
        if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) {
          if ("suspendedStart" === state) throw state = "completed", context.arg;
          context.dispatchException(context.arg);
        } else "return" === context.method && context.abrupt("return", context.arg);
        state = "executing";
        var record = tryCatch(innerFn, self, context);
        if ("normal" === record.type) {
          if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue;
          return {
            value: record.arg,
            done: context.done
          };
        }
        "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg);
      }
    };
  }
  function maybeInvokeDelegate(delegate, context) {
    var methodName = context.method,
      method = delegate.iterator[methodName];
    if (undefined === method) return context.delegate = null, "throw" === methodName && delegate.iterator.return && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method) || "return" !== methodName && (context.method = "throw", context.arg = new TypeError("The iterator does not provide a '" + methodName + "' method")), ContinueSentinel;
    var record = tryCatch(method, delegate.iterator, context.arg);
    if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel;
    var info = record.arg;
    return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel);
  }
  function pushTryEntry(locs) {
    var entry = {
      tryLoc: locs[0]
    };
    1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry);
  }
  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal", delete record.arg, entry.completion = record;
  }
  function Context(tryLocsList) {
    this.tryEntries = [{
      tryLoc: "root"
    }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0);
  }
  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) return iteratorMethod.call(iterable);
      if ("function" == typeof iterable.next) return iterable;
      if (!isNaN(iterable.length)) {
        var i = -1,
          next = function next() {
            for (; ++i < iterable.length;) if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next;
            return next.value = undefined, next.done = !0, next;
          };
        return next.next = next;
      }
    }
    return {
      next: doneResult
    };
  }
  function doneResult() {
    return {
      value: undefined,
      done: !0
    };
  }
  return GeneratorFunction.prototype = GeneratorFunctionPrototype, defineProperty(Gp, "constructor", {
    value: GeneratorFunctionPrototype,
    configurable: !0
  }), defineProperty(GeneratorFunctionPrototype, "constructor", {
    value: GeneratorFunction,
    configurable: !0
  }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) {
    var ctor = "function" == typeof genFun && genFun.constructor;
    return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name));
  }, exports.mark = function (genFun) {
    return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun;
  }, exports.awrap = function (arg) {
    return {
      __await: arg
    };
  }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () {
    return this;
  }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) {
    void 0 === PromiseImpl && (PromiseImpl = Promise);
    var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl);
    return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) {
      return result.done ? result.value : iter.next();
    });
  }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () {
    return this;
  }), define(Gp, "toString", function () {
    return "[object Generator]";
  }), exports.keys = function (val) {
    var object = Object(val),
      keys = [];
    for (var key in object) keys.push(key);
    return keys.reverse(), function next() {
      for (; keys.length;) {
        var key = keys.pop();
        if (key in object) return next.value = key, next.done = !1, next;
      }
      return next.done = !0, next;
    };
  }, exports.values = values, Context.prototype = {
    constructor: Context,
    reset: function (skipTempReset) {
      if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined);
    },
    stop: function () {
      this.done = !0;
      var rootRecord = this.tryEntries[0].completion;
      if ("throw" === rootRecord.type) throw rootRecord.arg;
      return this.rval;
    },
    dispatchException: function (exception) {
      if (this.done) throw exception;
      var context = this;
      function handle(loc, caught) {
        return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught;
      }
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i],
          record = entry.completion;
        if ("root" === entry.tryLoc) return handle("end");
        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc"),
            hasFinally = hasOwn.call(entry, "finallyLoc");
          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
            if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
          } else {
            if (!hasFinally) throw new Error("try statement without catch or finally");
            if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
          }
        }
      }
    },
    abrupt: function (type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }
      finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null);
      var record = finallyEntry ? finallyEntry.completion : {};
      return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record);
    },
    complete: function (record, afterLoc) {
      if ("throw" === record.type) throw record.arg;
      return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel;
    },
    finish: function (finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel;
      }
    },
    catch: function (tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;
          if ("throw" === record.type) {
            var thrown = record.arg;
            resetTryEntry(entry);
          }
          return thrown;
        }
      }
      throw new Error("illegal catch attempt");
    },
    delegateYield: function (iterable, resultName, nextLoc) {
      return this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      }, "next" === this.method && (this.arg = undefined), ContinueSentinel;
    }
  }, exports;
}
function _wrapAsyncGenerator(fn) {
  return function () {
    return new _AsyncGenerator(fn.apply(this, arguments));
  };
}
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }
  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}
function _asyncToGenerator(fn) {
  return function () {
    var self = this,
      args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);
      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }
      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }
      _next(undefined);
    });
  };
}
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;
  _setPrototypeOf(subClass, superClass);
}
function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}
function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };
  return _setPrototypeOf(o, p);
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
function _construct(Parent, args, Class) {
  if (_isNativeReflectConstruct()) {
    _construct = Reflect.construct.bind();
  } else {
    _construct = function _construct(Parent, args, Class) {
      var a = [null];
      a.push.apply(a, args);
      var Constructor = Function.bind.apply(Parent, a);
      var instance = new Constructor();
      if (Class) _setPrototypeOf(instance, Class.prototype);
      return instance;
    };
  }
  return _construct.apply(null, arguments);
}
function _isNativeFunction(fn) {
  return Function.toString.call(fn).indexOf("[native code]") !== -1;
}
function _wrapNativeSuper(Class) {
  var _cache = typeof Map === "function" ? new Map() : undefined;
  _wrapNativeSuper = function _wrapNativeSuper(Class) {
    if (Class === null || !_isNativeFunction(Class)) return Class;
    if (typeof Class !== "function") {
      throw new TypeError("Super expression must either be null or a function");
    }
    if (typeof _cache !== "undefined") {
      if (_cache.has(Class)) return _cache.get(Class);
      _cache.set(Class, Wrapper);
    }
    function Wrapper() {
      return _construct(Class, arguments, _getPrototypeOf(this).constructor);
    }
    Wrapper.prototype = Object.create(Class.prototype, {
      constructor: {
        value: Wrapper,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    return _setPrototypeOf(Wrapper, Class);
  };
  return _wrapNativeSuper(Class);
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}
function _createForOfIteratorHelperLoose(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
  if (it) return (it = it.call(o)).next.bind(it);
  if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
    if (it) o = it;
    var i = 0;
    return function () {
      if (i >= o.length) return {
        done: true
      };
      return {
        done: false,
        value: o[i++]
      };
    };
  }
  throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var hashJson = function hashJson() {
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }
  return JSON.stringify(args);
};
var isPromise = function isPromise(something) {
  return something && something.then && something.then.constructor === Function;
};
var ensurePromise = function ensurePromise(maybePromise) {
  return isPromise(maybePromise) ? maybePromise : Promise.resolve(maybePromise);
};
var series = /*#__PURE__*/function () {
  var _ref = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(array) {
    var result, _iterator, _step, val;
    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          result = [];
          _iterator = _createForOfIteratorHelperLoose(array);
        case 2:
          if ((_step = _iterator()).done) {
            _context.next = 16;
            break;
          }
          val = _step.value;
          _context.t0 = result;
          if (!isPromise(val)) {
            _context.next = 11;
            break;
          }
          _context.next = 8;
          return val;
        case 8:
          _context.t1 = _context.sent;
          _context.next = 12;
          break;
        case 11:
          _context.t1 = val;
        case 12:
          _context.t2 = _context.t1;
          _context.t0.push.call(_context.t0, _context.t2);
        case 14:
          _context.next = 2;
          break;
        case 16:
          return _context.abrupt("return", result);
        case 17:
        case "end":
          return _context.stop();
      }
    }, _callee);
  }));
  return function series(_x) {
    return _ref.apply(this, arguments);
  };
}();
var flow = function flow() {
  for (var _len2 = arguments.length, array = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    array[_key2] = arguments[_key2];
  }
  return /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(result) {
      var _i, _array, val;
      return _regeneratorRuntime().wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            _i = 0, _array = array;
          case 1:
            if (!(_i < _array.length)) {
              _context2.next = 15;
              break;
            }
            val = _array[_i];
            result = val(result);
            if (!isPromise(result)) {
              _context2.next = 10;
              break;
            }
            _context2.next = 7;
            return result;
          case 7:
            _context2.t0 = _context2.sent;
            _context2.next = 11;
            break;
          case 10:
            _context2.t0 = result;
          case 11:
            result = _context2.t0;
          case 12:
            _i++;
            _context2.next = 1;
            break;
          case 15:
            return _context2.abrupt("return", result);
          case 16:
          case "end":
            return _context2.stop();
        }
      }, _callee2);
    }));
    return function (_x2) {
      return _ref2.apply(this, arguments);
    };
  }();
};
var maybePromiseResolve = /*#__PURE__*/function () {
  var _ref3 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3(val) {
    return _regeneratorRuntime().wrap(function _callee3$(_context3) {
      while (1) switch (_context3.prev = _context3.next) {
        case 0:
          if (!isPromise(val)) {
            _context3.next = 6;
            break;
          }
          _context3.next = 3;
          return val;
        case 3:
          _context3.t0 = _context3.sent;
          _context3.next = 7;
          break;
        case 6:
          _context3.t0 = val;
        case 7:
          return _context3.abrupt("return", _context3.t0);
        case 8:
        case "end":
          return _context3.stop();
      }
    }, _callee3);
  }));
  return function maybePromiseResolve(_x3) {
    return _ref3.apply(this, arguments);
  };
}();
var propsResolveSeries = /*#__PURE__*/function () {
  var _ref4 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee4(dict) {
    var result, _i2, _Object$keys, key;
    return _regeneratorRuntime().wrap(function _callee4$(_context4) {
      while (1) switch (_context4.prev = _context4.next) {
        case 0:
          result = {};
          _i2 = 0, _Object$keys = Object.keys(dict);
        case 2:
          if (!(_i2 < _Object$keys.length)) {
            _context4.next = 10;
            break;
          }
          key = _Object$keys[_i2];
          _context4.next = 6;
          return maybePromiseResolve(dict[key]);
        case 6:
          result[key] = _context4.sent;
        case 7:
          _i2++;
          _context4.next = 2;
          break;
        case 10:
          return _context4.abrupt("return", result);
        case 11:
        case "end":
          return _context4.stop();
      }
    }, _callee4);
  }));
  return function propsResolveSeries(_x4) {
    return _ref4.apply(this, arguments);
  };
}();
var propsResolve = propsResolveSeries; // todo parallel
var cache = function cache(store, hash) {
  if (hash === void 0) {
    hash = hashJson;
  }
  return function (f) {
    return function () {
      for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        args[_key3] = arguments[_key3];
      }
      return new Promise(function (resolve, reject) {
        var argHash = hash(args);
        store.get(argHash).then(function (ret) {
          if (ret) {
            resolve(ret);
          } else {
            f.apply(void 0, args).then(function (ret) {
              return store.set(argHash, ret);
            }).then(resolve)["catch"](reject);
          }
        });
      });
    };
  };
};
// export const depthFirstMap = async (dict, mapper) => {
//   const result = {}
//   for (let key of Object.keys(dict)) {
//     const val = dict[key]
//     result[key] = isDict(val)
//       ? await depthFirstMap(val, mapper)
//       : await mapper(val)
//   }
//   return result
// }
// export const each = async function(mapper, array) {
//   let res: MaybePromise<any>
//   for (const element of array) {
//     res = mapper(element)
//     if (isPromise(res)) {
//       await res
//     }
//   }
// }
// export const map = async function(mapper, array: Array<any>) {
//   let result: Array<any> = []
//   let res: MaybePromise<any>
//   for (const element of array) {
//     res = mapper(element)
//     result.push(isPromise(res) ? await res : res)
//   }
// }
var delay$1 = function delay(n, f) {
  return function () {
    return new Promise(function (resolve) {
      setTimeout(function () {
        return f().then(resolve);
      }, n);
    });
  };
};
var times = /*#__PURE__*/function () {
  var _ref5 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee5(n, f) {
    return _regeneratorRuntime().wrap(function _callee5$(_context5) {
      while (1) switch (_context5.prev = _context5.next) {
        case 0:
          if (!n) {
            _context5.next = 11;
            break;
          }
          _context5.next = 3;
          return f();
        case 3:
          _context5.t2 = _context5.sent;
          _context5.t1 = [_context5.t2];
          _context5.next = 7;
          return times(n - 1, f);
        case 7:
          _context5.t3 = _context5.sent;
          _context5.t0 = _context5.t1.concat.call(_context5.t1, _context5.t3);
          _context5.next = 15;
          break;
        case 11:
          _context5.next = 13;
          return f();
        case 13:
          _context5.t4 = _context5.sent;
          _context5.t0 = [_context5.t4];
        case 15:
          return _context5.abrupt("return", _context5.t0);
        case 16:
        case "end":
          return _context5.stop();
      }
    }, _callee5);
  }));
  return function times(_x5, _x6) {
    return _ref5.apply(this, arguments);
  };
}();

var promise = {
  __proto__: null,
  cache: cache,
  delay: delay$1,
  ensurePromise: ensurePromise,
  flow: flow,
  hashJson: hashJson,
  isPromise: isPromise,
  maybePromiseResolve: maybePromiseResolve,
  propsResolve: propsResolve,
  propsResolveSeries: propsResolveSeries,
  series: series,
  times: times
};

// efficient common set operations
//
// TS insights not helpful here so simply ignored a bunch of lines
// would be curious if someone knows how to type this tho
function isSuperset(superSet, subset) {
  for (var _iterator = _createForOfIteratorHelperLoose(subset), _step; !(_step = _iterator()).done;) {
    var elem = _step.value;
    if (!superSet.has(elem)) {
      return false;
    }
  }
  return true;
}
function union(setA, setB) {
  var _union = new Set(setA);
  for (var _iterator2 = _createForOfIteratorHelperLoose(setB), _step2; !(_step2 = _iterator2()).done;) {
    var elem = _step2.value;
    _union.add(elem);
  }
  return _union;
}
function intersection(setA, setB) {
  var _intersection = new Set();
  for (var _iterator3 = _createForOfIteratorHelperLoose(setB), _step3; !(_step3 = _iterator3()).done;) {
    var elem = _step3.value;
    // @ts-ignore
    if (setA.has(elem)) {
      _intersection.add(elem);
    }
  }
  return _intersection;
}
function symmetricDifference(setA, setB) {
  var _difference = new Set(setA);
  // @ts-ignore
  for (var _iterator4 = _createForOfIteratorHelperLoose(setB), _step4; !(_step4 = _iterator4()).done;) {
    var elem = _step4.value;
    // @ts-ignore
    if (_difference.has(elem)) {
      // @ts-ignore
      _difference["delete"](elem);
    } else {
      // @ts-ignore
      _difference.add(elem);
    }
  }
  return _difference;
}
function difference(setA, setB) {
  var _difference = new Set(setA);
  for (var _iterator5 = _createForOfIteratorHelperLoose(setB), _step5; !(_step5 = _iterator5()).done;) {
    var elem = _step5.value;
    // @ts-ignore
    _difference["delete"](elem);
  }
  return _difference;
}

var set = {
  __proto__: null,
  difference: difference,
  intersection: intersection,
  isSuperset: isSuperset,
  symmetricDifference: symmetricDifference,
  union: union
};

var _flow = /*#__PURE__*/require('lodash/flow');
var _isFunction = /*#__PURE__*/require('lodash/isFunction');
var mapValues = /*#__PURE__*/require('lodash/mapValues');
var flatten = /*#__PURE__*/require('lodash/flatten');
var fpReduce = /*#__PURE__*/require('lodash/fp/reduce');
var fpMapValues = /*#__PURE__*/require('lodash/fp/mapValues');
var _mergeWith = /*#__PURE__*/require('lodash/mergeWith');
var _set = /*#__PURE__*/require('lodash/set');
var clone = /*#__PURE__*/require('lodash/clone');
var head = /*#__PURE__*/require('lodash/head');
var ajv = /*#__PURE__*/new Ajv({
  useDefaults: true
});
var joinPath = function joinPath() {
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }
  return path__namespace.join(head(flatten(args)));
};
var fpMapValuesWithKey = /*#__PURE__*/fpMapValues.convert({
  cap: false
});
var depthFirstMap = function depthFirstMap(callback) {
  return fpMapValuesWithKey(function (value, key) {
    return isDict(value) ? depthFirstMap(callback)(value, key) : callback(value, key);
  });
};
function mutableDeepMergeTwo(dict1, dict2) {
  return _mergeWith(dict1, dict2, function (dst, src) {
    if (dst === undefined) {
      return src;
    } else if (isDict(dst) && isDict(src)) {
      return deepMerge(dst, src);
    } else {
      return src;
    }
  });
}
function mutableDeepMerge(dict) {
  for (var _len2 = arguments.length, dicts = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
    dicts[_key2 - 1] = arguments[_key2];
  }
  return fpReduce(mutableDeepMergeTwo, dict)(dicts);
}
function deepMerge() {
  var accumulator = {};
  for (var _len3 = arguments.length, dicts = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
    dicts[_key3] = arguments[_key3];
  }
  return fpReduce(mutableDeepMergeTwo, accumulator)(dicts);
}
// functional mutable push (mutable for speed)
var push = function push(array) {
  return function (value) {
    array.push(value);
    return array;
  };
};
// could have composed map and filter but didn't like building intermediate data structures between them
var mapFilter = function mapFilter(callback) {
  var accumulator = [];
  return fpReduce(function (results, item) {
    if (results === void 0) {
      results = [];
    }
    var result = callback(item);
    return result === undefined ? results : push(results)(result);
  }, accumulator);
};
var transform = function transform(attr) {
  return function (transformer) {
    return function (obj) {
      return _set(_extends({}, obj), attr, transformer(obj[attr], attr));
    };
  };
};
// https://www.typescriptlang.org/docs/handbook/mixins.html
function applyMixins(derivedCtor, baseCtors) {
  baseCtors.forEach(function (baseCtor) {
    Object.getOwnPropertyNames(baseCtor.prototype).forEach(function (name) {
      Object.defineProperty(derivedCtor.prototype, name,
      // @ts-ignore
      Object.getOwnPropertyDescriptor(baseCtor.prototype, name));
    });
  });
}
var propsCall = function propsCall(props) {
  return mapValues(props, maybeFunctionCall);
};
var propsExec = /*#__PURE__*/_flow([propsCall, propsResolve]);
var maybeFunctionCall = function maybeFunctionCall(val) {
  return isFunction(val) ? val() : val;
};
var exec = /*#__PURE__*/_flow([maybeFunctionCall, maybePromiseResolve]);
// for type guards
var isString = function isString(x) {
  return typeof x === 'string';
};
var isNumber = function isNumber(x) {
  return typeof x === 'number';
};
var isFunction = function isFunction(something) {
  return _isFunction(something);
};
function isArray(v) {
  return typeof v === 'object' && v !== null && v instanceof Array;
}
function isDict(v) {
  return typeof v === 'object' && v !== null && !(v instanceof Array) && !(v instanceof Date) && !(v instanceof Promise);
}
function notExists(value) {
  return value === undefined || value === null;
}
function exists(value) {
  return value !== undefined && value !== null;
}
// wow this is difficult to but simple.
// its a function wrapper that applies defaults to arguments
//
// unit test looks like this:
//
//     const wrapped = utils.args({ a: 1, b: 2 })(opts =>
//      expect(opts).toEqual({ a: 1, b: 3 })
//    )
//    wrapped({ b: 3 })
//
var args = function args(defaultArguments) {
  return function (targetFunction) {
    return function (args) {
      return targetFunction(deepMerge(defaultArguments, args));
    };
  };
};
// same as the above, just using a JSON validator
var ArgumentValidationError = /*#__PURE__*/function (_Error) {
  _inheritsLoose(ArgumentValidationError, _Error);
  function ArgumentValidationError() {
    return _Error.apply(this, arguments) || this;
  }
  return ArgumentValidationError;
}( /*#__PURE__*/_wrapNativeSuper(Error));
var argsSchema = function argsSchema(schema) {
  var compiledSchema = ajv.compile(schema);
  return function (targetFunction) {
    return function (args) {
      var argsClone = clone(args);
      if (!compiledSchema(argsClone)) {
        var error = head(compiledSchema.errors);
        throw new ArgumentValidationError(error.dataPath + " " + error.message);
      }
      return targetFunction(argsClone);
    };
  };
};

var index$2 = {
  __proto__: null,
  ArgumentValidationError: ArgumentValidationError,
  ajv: ajv,
  applyMixins: applyMixins,
  args: args,
  argsSchema: argsSchema,
  deepMerge: deepMerge,
  depthFirstMap: depthFirstMap,
  exec: exec,
  exists: exists,
  fpMapValuesWithKey: fpMapValuesWithKey,
  isArray: isArray,
  isDict: isDict,
  isFunction: isFunction,
  isNumber: isNumber,
  isString: isString,
  joinPath: joinPath,
  mapFilter: mapFilter,
  maybeFunctionCall: maybeFunctionCall,
  mutableDeepMerge: mutableDeepMerge,
  mutableDeepMergeTwo: mutableDeepMergeTwo,
  notExists: notExists,
  promise: promise,
  propsCall: propsCall,
  propsExec: propsExec,
  push: push,
  set: set,
  transform: transform
};

var applyDefaults = function applyDefaults(defaultConfig, f) {
  return function (optArgConfig) {
    return f(deepMerge(defaultConfig, optArgConfig || {}));
  };
};

var wrap = {
  __proto__: null,
  applyDefaults: applyDefaults
};

var init$1 = function init(config) {
  if (!config.productionConsole) {
    var targets = [];
    var transports = config.transports;
    if (transports.console && transports.console.enabled) {
      targets.push({
        level: 'debug',
        target: 'pino-pretty',
        options: {}
      });
    }
    if (transports.file && transports.file.enabled) {
      targets.push({
        level: 'trace',
        target: 'pino/file',
        options: lodash.omit(transports.file, 'enabled')
      });
    }
    if (transports.datadog && transports.datadog.enabled) {
      targets.push({
        level: 'debug',
        target: './datadog',
        options: _extends({}, lodash.omit(transports.datadog, 'enabled'), {
          host: os.hostname()
        })
      });
    }
    return pino({
      base: {
        host: os.hostname(),
        service: config.name,
        env: config.env
      }
    }, pino.transport({
      targets: targets
    }));
  }
  return pino({
    base: {
      host: os.hostname(),
      service: config.name,
      env: config.env
    }
  });
};

var logger = {
  __proto__: null,
  init: init$1,
  pino: pino
};

// curry pipe
var cpipe = fp.pipe;
var pipe = function pipe(input) {
  for (var _len = arguments.length, chain = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    chain[_key - 1] = arguments[_key];
  }
  return fp.pipe.apply(fp, chain)(input);
};
var filter = function filter(f) {
  return /*#__PURE__*/function () {
    var _ref = _wrapAsyncGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(iterator) {
      var _iteratorAbruptCompletion, _didIteratorError, _iteratorError, _iterator, _step, el;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            _iteratorAbruptCompletion = false;
            _didIteratorError = false;
            _context.prev = 2;
            _iterator = _asyncIterator(iterator);
          case 4:
            _context.next = 6;
            return _awaitAsyncGenerator(_iterator.next());
          case 6:
            if (!(_iteratorAbruptCompletion = !(_step = _context.sent).done)) {
              _context.next = 16;
              break;
            }
            el = _step.value;
            _context.next = 10;
            return _awaitAsyncGenerator(f(el));
          case 10:
            if (!_context.sent) {
              _context.next = 13;
              break;
            }
            _context.next = 13;
            return el;
          case 13:
            _iteratorAbruptCompletion = false;
            _context.next = 4;
            break;
          case 16:
            _context.next = 22;
            break;
          case 18:
            _context.prev = 18;
            _context.t0 = _context["catch"](2);
            _didIteratorError = true;
            _iteratorError = _context.t0;
          case 22:
            _context.prev = 22;
            _context.prev = 23;
            if (!(_iteratorAbruptCompletion && _iterator["return"] != null)) {
              _context.next = 27;
              break;
            }
            _context.next = 27;
            return _awaitAsyncGenerator(_iterator["return"]());
          case 27:
            _context.prev = 27;
            if (!_didIteratorError) {
              _context.next = 30;
              break;
            }
            throw _iteratorError;
          case 30:
            return _context.finish(27);
          case 31:
            return _context.finish(22);
          case 32:
          case "end":
            return _context.stop();
        }
      }, _callee, null, [[2, 18, 22, 32], [23,, 27, 31]]);
    }));
    return function (_x) {
      return _ref.apply(this, arguments);
    };
  }();
};
var map = function map(f) {
  return /*#__PURE__*/function () {
    var _ref2 = _wrapAsyncGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(iterator) {
      var _iteratorAbruptCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, el;
      return _regeneratorRuntime().wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            _iteratorAbruptCompletion2 = false;
            _didIteratorError2 = false;
            _context2.prev = 2;
            _iterator2 = _asyncIterator(iterator);
          case 4:
            _context2.next = 6;
            return _awaitAsyncGenerator(_iterator2.next());
          case 6:
            if (!(_iteratorAbruptCompletion2 = !(_step2 = _context2.sent).done)) {
              _context2.next = 15;
              break;
            }
            el = _step2.value;
            _context2.next = 10;
            return _awaitAsyncGenerator(f(el));
          case 10:
            _context2.next = 12;
            return _context2.sent;
          case 12:
            _iteratorAbruptCompletion2 = false;
            _context2.next = 4;
            break;
          case 15:
            _context2.next = 21;
            break;
          case 17:
            _context2.prev = 17;
            _context2.t0 = _context2["catch"](2);
            _didIteratorError2 = true;
            _iteratorError2 = _context2.t0;
          case 21:
            _context2.prev = 21;
            _context2.prev = 22;
            if (!(_iteratorAbruptCompletion2 && _iterator2["return"] != null)) {
              _context2.next = 26;
              break;
            }
            _context2.next = 26;
            return _awaitAsyncGenerator(_iterator2["return"]());
          case 26:
            _context2.prev = 26;
            if (!_didIteratorError2) {
              _context2.next = 29;
              break;
            }
            throw _iteratorError2;
          case 29:
            return _context2.finish(26);
          case 30:
            return _context2.finish(21);
          case 31:
          case "end":
            return _context2.stop();
        }
      }, _callee2, null, [[2, 17, 21, 31], [22,, 26, 30]]);
    }));
    return function (_x2) {
      return _ref2.apply(this, arguments);
    };
  }();
};
var probe = function probe(f) {
  return /*#__PURE__*/function () {
    var _ref3 = _wrapAsyncGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3(iterator) {
      var _iteratorAbruptCompletion3, _didIteratorError3, _iteratorError3, _iterator3, _step3, el;
      return _regeneratorRuntime().wrap(function _callee3$(_context3) {
        while (1) switch (_context3.prev = _context3.next) {
          case 0:
            _iteratorAbruptCompletion3 = false;
            _didIteratorError3 = false;
            _context3.prev = 2;
            _iterator3 = _asyncIterator(iterator);
          case 4:
            _context3.next = 6;
            return _awaitAsyncGenerator(_iterator3.next());
          case 6:
            if (!(_iteratorAbruptCompletion3 = !(_step3 = _context3.sent).done)) {
              _context3.next = 15;
              break;
            }
            el = _step3.value;
            _context3.next = 10;
            return _awaitAsyncGenerator(f(el));
          case 10:
            _context3.next = 12;
            return el;
          case 12:
            _iteratorAbruptCompletion3 = false;
            _context3.next = 4;
            break;
          case 15:
            _context3.next = 21;
            break;
          case 17:
            _context3.prev = 17;
            _context3.t0 = _context3["catch"](2);
            _didIteratorError3 = true;
            _iteratorError3 = _context3.t0;
          case 21:
            _context3.prev = 21;
            _context3.prev = 22;
            if (!(_iteratorAbruptCompletion3 && _iterator3["return"] != null)) {
              _context3.next = 26;
              break;
            }
            _context3.next = 26;
            return _awaitAsyncGenerator(_iterator3["return"]());
          case 26:
            _context3.prev = 26;
            if (!_didIteratorError3) {
              _context3.next = 29;
              break;
            }
            throw _iteratorError3;
          case 29:
            return _context3.finish(26);
          case 30:
            return _context3.finish(21);
          case 31:
          case "end":
            return _context3.stop();
        }
      }, _callee3, null, [[2, 17, 21, 31], [22,, 26, 30]]);
    }));
    return function (_x3) {
      return _ref3.apply(this, arguments);
    };
  }();
};
var window = function window(n) {
  return /*#__PURE__*/function () {
    var _ref4 = _wrapAsyncGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee4(iterator) {
      var store, _iteratorAbruptCompletion4, _didIteratorError4, _iteratorError4, _iterator4, _step4, el;
      return _regeneratorRuntime().wrap(function _callee4$(_context4) {
        while (1) switch (_context4.prev = _context4.next) {
          case 0:
            store = [];
            _iteratorAbruptCompletion4 = false;
            _didIteratorError4 = false;
            _context4.prev = 3;
            _iterator4 = _asyncIterator(iterator);
          case 5:
            _context4.next = 7;
            return _awaitAsyncGenerator(_iterator4.next());
          case 7:
            if (!(_iteratorAbruptCompletion4 = !(_step4 = _context4.sent).done)) {
              _context4.next = 17;
              break;
            }
            el = _step4.value;
            store.push(el);
            if (!(store.length === n)) {
              _context4.next = 14;
              break;
            }
            _context4.next = 13;
            return store;
          case 13:
            store = [];
          case 14:
            _iteratorAbruptCompletion4 = false;
            _context4.next = 5;
            break;
          case 17:
            _context4.next = 23;
            break;
          case 19:
            _context4.prev = 19;
            _context4.t0 = _context4["catch"](3);
            _didIteratorError4 = true;
            _iteratorError4 = _context4.t0;
          case 23:
            _context4.prev = 23;
            _context4.prev = 24;
            if (!(_iteratorAbruptCompletion4 && _iterator4["return"] != null)) {
              _context4.next = 28;
              break;
            }
            _context4.next = 28;
            return _awaitAsyncGenerator(_iterator4["return"]());
          case 28:
            _context4.prev = 28;
            if (!_didIteratorError4) {
              _context4.next = 31;
              break;
            }
            throw _iteratorError4;
          case 31:
            return _context4.finish(28);
          case 32:
            return _context4.finish(23);
          case 33:
            if (!store.length) {
              _context4.next = 36;
              break;
            }
            _context4.next = 36;
            return store;
          case 36:
          case "end":
            return _context4.stop();
        }
      }, _callee4, null, [[3, 19, 23, 33], [24,, 28, 32]]);
    }));
    return function (_x4) {
      return _ref4.apply(this, arguments);
    };
  }();
};
function sequence(_x5, _x6) {
  return _sequence.apply(this, arguments);
}
function _sequence() {
  _sequence = _wrapAsyncGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee5(start, end) {
    var i;
    return _regeneratorRuntime().wrap(function _callee5$(_context5) {
      while (1) switch (_context5.prev = _context5.next) {
        case 0:
          i = start;
        case 1:
          if (!(i <= end)) {
            _context5.next = 7;
            break;
          }
          _context5.next = 4;
          return i;
        case 4:
          i++;
          _context5.next = 1;
          break;
        case 7:
        case "end":
          return _context5.stop();
      }
    }, _callee5);
  }));
  return _sequence.apply(this, arguments);
}
var delay = function delay(delayTime) {
  if (delayTime === void 0) {
    delayTime = 1000;
  }
  return /*#__PURE__*/function () {
    var _ref5 = _wrapAsyncGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee6(iterator) {
      var _iteratorAbruptCompletion5, _didIteratorError5, _iteratorError5, _iterator5, _step5, el;
      return _regeneratorRuntime().wrap(function _callee6$(_context6) {
        while (1) switch (_context6.prev = _context6.next) {
          case 0:
            _iteratorAbruptCompletion5 = false;
            _didIteratorError5 = false;
            _context6.prev = 2;
            _iterator5 = _asyncIterator(iterator);
          case 4:
            _context6.next = 6;
            return _awaitAsyncGenerator(_iterator5.next());
          case 6:
            if (!(_iteratorAbruptCompletion5 = !(_step5 = _context6.sent).done)) {
              _context6.next = 15;
              break;
            }
            el = _step5.value;
            _context6.next = 10;
            return _awaitAsyncGenerator(new Promise(function (resolve) {
              return setTimeout(resolve, delayTime);
            }));
          case 10:
            _context6.next = 12;
            return el;
          case 12:
            _iteratorAbruptCompletion5 = false;
            _context6.next = 4;
            break;
          case 15:
            _context6.next = 21;
            break;
          case 17:
            _context6.prev = 17;
            _context6.t0 = _context6["catch"](2);
            _didIteratorError5 = true;
            _iteratorError5 = _context6.t0;
          case 21:
            _context6.prev = 21;
            _context6.prev = 22;
            if (!(_iteratorAbruptCompletion5 && _iterator5["return"] != null)) {
              _context6.next = 26;
              break;
            }
            _context6.next = 26;
            return _awaitAsyncGenerator(_iterator5["return"]());
          case 26:
            _context6.prev = 26;
            if (!_didIteratorError5) {
              _context6.next = 29;
              break;
            }
            throw _iteratorError5;
          case 29:
            return _context6.finish(26);
          case 30:
            return _context6.finish(21);
          case 31:
          case "end":
            return _context6.stop();
        }
      }, _callee6, null, [[2, 17, 21, 31], [22,, 26, 30]]);
    }));
    return function (_x7) {
      return _ref5.apply(this, arguments);
    };
  }();
};
var skip = function skip(start) {
  return /*#__PURE__*/function () {
    var _ref6 = _wrapAsyncGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee7(node) {
      var counter, _iteratorAbruptCompletion6, _didIteratorError6, _iteratorError6, _iterator6, _step6, msg;
      return _regeneratorRuntime().wrap(function _callee7$(_context7) {
        while (1) switch (_context7.prev = _context7.next) {
          case 0:
            counter = 0;
            _iteratorAbruptCompletion6 = false;
            _didIteratorError6 = false;
            _context7.prev = 3;
            _iterator6 = _asyncIterator(node);
          case 5:
            _context7.next = 7;
            return _awaitAsyncGenerator(_iterator6.next());
          case 7:
            if (!(_iteratorAbruptCompletion6 = !(_step6 = _context7.sent).done)) {
              _context7.next = 16;
              break;
            }
            msg = _step6.value;
            counter++;
            if (!(counter > start)) {
              _context7.next = 13;
              break;
            }
            _context7.next = 13;
            return msg;
          case 13:
            _iteratorAbruptCompletion6 = false;
            _context7.next = 5;
            break;
          case 16:
            _context7.next = 22;
            break;
          case 18:
            _context7.prev = 18;
            _context7.t0 = _context7["catch"](3);
            _didIteratorError6 = true;
            _iteratorError6 = _context7.t0;
          case 22:
            _context7.prev = 22;
            _context7.prev = 23;
            if (!(_iteratorAbruptCompletion6 && _iterator6["return"] != null)) {
              _context7.next = 27;
              break;
            }
            _context7.next = 27;
            return _awaitAsyncGenerator(_iterator6["return"]());
          case 27:
            _context7.prev = 27;
            if (!_didIteratorError6) {
              _context7.next = 30;
              break;
            }
            throw _iteratorError6;
          case 30:
            return _context7.finish(27);
          case 31:
            return _context7.finish(22);
          case 32:
          case "end":
            return _context7.stop();
        }
      }, _callee7, null, [[3, 18, 22, 32], [23,, 27, 31]]);
    }));
    return function (_x8) {
      return _ref6.apply(this, arguments);
    };
  }();
};
var limit = function limit(end) {
  return /*#__PURE__*/function () {
    var _ref7 = _wrapAsyncGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee8(node) {
      var counter, _iteratorAbruptCompletion7, _didIteratorError7, _iteratorError7, _iterator7, _step7, msg;
      return _regeneratorRuntime().wrap(function _callee8$(_context8) {
        while (1) switch (_context8.prev = _context8.next) {
          case 0:
            counter = 0;
            _iteratorAbruptCompletion7 = false;
            _didIteratorError7 = false;
            _context8.prev = 3;
            _iterator7 = _asyncIterator(node);
          case 5:
            _context8.next = 7;
            return _awaitAsyncGenerator(_iterator7.next());
          case 7:
            if (!(_iteratorAbruptCompletion7 = !(_step7 = _context8.sent).done)) {
              _context8.next = 17;
              break;
            }
            msg = _step7.value;
            counter++;
            _context8.next = 12;
            return msg;
          case 12:
            if (!(counter === end)) {
              _context8.next = 14;
              break;
            }
            return _context8.abrupt("break", 17);
          case 14:
            _iteratorAbruptCompletion7 = false;
            _context8.next = 5;
            break;
          case 17:
            _context8.next = 23;
            break;
          case 19:
            _context8.prev = 19;
            _context8.t0 = _context8["catch"](3);
            _didIteratorError7 = true;
            _iteratorError7 = _context8.t0;
          case 23:
            _context8.prev = 23;
            _context8.prev = 24;
            if (!(_iteratorAbruptCompletion7 && _iterator7["return"] != null)) {
              _context8.next = 28;
              break;
            }
            _context8.next = 28;
            return _awaitAsyncGenerator(_iterator7["return"]());
          case 28:
            _context8.prev = 28;
            if (!_didIteratorError7) {
              _context8.next = 31;
              break;
            }
            throw _iteratorError7;
          case 31:
            return _context8.finish(28);
          case 32:
            return _context8.finish(23);
          case 33:
          case "end":
            return _context8.stop();
        }
      }, _callee8, null, [[3, 19, 23, 33], [24,, 28, 32]]);
    }));
    return function (_x9) {
      return _ref7.apply(this, arguments);
    };
  }();
};
var slice = function slice(start, end) {
  if (start === void 0) {
    start = 0;
  }
  if (end === void 0) {
    end = Infinity;
  }
  return fp.pipe(skip(start), limit(end));
};
var pullCount = function pullCount() {
  return /*#__PURE__*/function () {
    var _ref16 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee9(node) {
      var cnt, _iteratorAbruptCompletion8, _didIteratorError8, _iteratorError8, _iterator8;
      return _regeneratorRuntime().wrap(function _callee9$(_context9) {
        while (1) switch (_context9.prev = _context9.next) {
          case 0:
            cnt = 0;
            _iteratorAbruptCompletion8 = false;
            _didIteratorError8 = false;
            _context9.prev = 3;
            _iterator8 = _asyncIterator(node);
          case 5:
            _context9.next = 7;
            return _iterator8.next();
          case 7:
            if (!(_iteratorAbruptCompletion8 = !(_context9.sent).done)) {
              _context9.next = 14;
              break;
            }
            cnt++;
          case 11:
            _iteratorAbruptCompletion8 = false;
            _context9.next = 5;
            break;
          case 14:
            _context9.next = 20;
            break;
          case 16:
            _context9.prev = 16;
            _context9.t0 = _context9["catch"](3);
            _didIteratorError8 = true;
            _iteratorError8 = _context9.t0;
          case 20:
            _context9.prev = 20;
            _context9.prev = 21;
            if (!(_iteratorAbruptCompletion8 && _iterator8["return"] != null)) {
              _context9.next = 25;
              break;
            }
            _context9.next = 25;
            return _iterator8["return"]();
          case 25:
            _context9.prev = 25;
            if (!_didIteratorError8) {
              _context9.next = 28;
              break;
            }
            throw _iteratorError8;
          case 28:
            return _context9.finish(25);
          case 29:
            return _context9.finish(20);
          case 30:
            return _context9.abrupt("return", cnt);
          case 31:
          case "end":
            return _context9.stop();
        }
      }, _callee9, null, [[3, 16, 20, 30], [21,, 25, 29]]);
    }));
    return function (_x14) {
      return _ref16.apply(this, arguments);
    };
  }();
};
var pullAll = function pullAll() {
  return /*#__PURE__*/function () {
    var _ref17 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee10(node) {
      var _iteratorAbruptCompletion9, _didIteratorError9, _iteratorError9, _iterator9;
      return _regeneratorRuntime().wrap(function _callee10$(_context10) {
        while (1) switch (_context10.prev = _context10.next) {
          case 0:
            _iteratorAbruptCompletion9 = false;
            _didIteratorError9 = false;
            _context10.prev = 2;
            _iterator9 = _asyncIterator(node);
          case 4:
            _context10.next = 6;
            return _iterator9.next();
          case 6:
            if (!(_iteratorAbruptCompletion9 = !(_context10.sent).done)) {
              _context10.next = 12;
              break;
            }
          case 9:
            _iteratorAbruptCompletion9 = false;
            _context10.next = 4;
            break;
          case 12:
            _context10.next = 18;
            break;
          case 14:
            _context10.prev = 14;
            _context10.t0 = _context10["catch"](2);
            _didIteratorError9 = true;
            _iteratorError9 = _context10.t0;
          case 18:
            _context10.prev = 18;
            _context10.prev = 19;
            if (!(_iteratorAbruptCompletion9 && _iterator9["return"] != null)) {
              _context10.next = 23;
              break;
            }
            _context10.next = 23;
            return _iterator9["return"]();
          case 23:
            _context10.prev = 23;
            if (!_didIteratorError9) {
              _context10.next = 26;
              break;
            }
            throw _iteratorError9;
          case 26:
            return _context10.finish(23);
          case 27:
            return _context10.finish(18);
          case 28:
          case "end":
            return _context10.stop();
        }
      }, _callee10, null, [[2, 14, 18, 28], [19,, 23, 27]]);
    }));
    return function (_x15) {
      return _ref17.apply(this, arguments);
    };
  }();
};
var pullArray = function pullArray() {
  return /*#__PURE__*/function () {
    var _ref18 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee11(node) {
      var ret, _iteratorAbruptCompletion10, _didIteratorError10, _iteratorError10, _iterator10, _step10, msg;
      return _regeneratorRuntime().wrap(function _callee11$(_context11) {
        while (1) switch (_context11.prev = _context11.next) {
          case 0:
            ret = [];
            _iteratorAbruptCompletion10 = false;
            _didIteratorError10 = false;
            _context11.prev = 3;
            _iterator10 = _asyncIterator(node);
          case 5:
            _context11.next = 7;
            return _iterator10.next();
          case 7:
            if (!(_iteratorAbruptCompletion10 = !(_step10 = _context11.sent).done)) {
              _context11.next = 13;
              break;
            }
            msg = _step10.value;
            ret.push(msg);
          case 10:
            _iteratorAbruptCompletion10 = false;
            _context11.next = 5;
            break;
          case 13:
            _context11.next = 19;
            break;
          case 15:
            _context11.prev = 15;
            _context11.t0 = _context11["catch"](3);
            _didIteratorError10 = true;
            _iteratorError10 = _context11.t0;
          case 19:
            _context11.prev = 19;
            _context11.prev = 20;
            if (!(_iteratorAbruptCompletion10 && _iterator10["return"] != null)) {
              _context11.next = 24;
              break;
            }
            _context11.next = 24;
            return _iterator10["return"]();
          case 24:
            _context11.prev = 24;
            if (!_didIteratorError10) {
              _context11.next = 27;
              break;
            }
            throw _iteratorError10;
          case 27:
            return _context11.finish(24);
          case 28:
            return _context11.finish(19);
          case 29:
            return _context11.abrupt("return", ret);
          case 30:
          case "end":
            return _context11.stop();
        }
      }, _callee11, null, [[3, 15, 19, 29], [20,, 24, 28]]);
    }));
    return function (_x16) {
      return _ref18.apply(this, arguments);
    };
  }();
};
var pull = function pull(x) {
  return x ? fp.pipe(limit(x), pullAll()) : pullAll();
};
var catchLast = function catchLast(cb) {
  return /*#__PURE__*/function () {
    var _ref8 = _wrapAsyncGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee12(node) {
      var last, _iteratorAbruptCompletion11, _didIteratorError11, _iteratorError11, _iterator11, _step11, event;
      return _regeneratorRuntime().wrap(function _callee12$(_context12) {
        while (1) switch (_context12.prev = _context12.next) {
          case 0:
            _iteratorAbruptCompletion11 = false;
            _didIteratorError11 = false;
            _context12.prev = 2;
            _iterator11 = _asyncIterator(node);
          case 4:
            _context12.next = 6;
            return _awaitAsyncGenerator(_iterator11.next());
          case 6:
            if (!(_iteratorAbruptCompletion11 = !(_step11 = _context12.sent).done)) {
              _context12.next = 14;
              break;
            }
            event = _step11.value;
            last = event;
            _context12.next = 11;
            return event;
          case 11:
            _iteratorAbruptCompletion11 = false;
            _context12.next = 4;
            break;
          case 14:
            _context12.next = 20;
            break;
          case 16:
            _context12.prev = 16;
            _context12.t0 = _context12["catch"](2);
            _didIteratorError11 = true;
            _iteratorError11 = _context12.t0;
          case 20:
            _context12.prev = 20;
            _context12.prev = 21;
            if (!(_iteratorAbruptCompletion11 && _iterator11["return"] != null)) {
              _context12.next = 25;
              break;
            }
            _context12.next = 25;
            return _awaitAsyncGenerator(_iterator11["return"]());
          case 25:
            _context12.prev = 25;
            if (!_didIteratorError11) {
              _context12.next = 28;
              break;
            }
            throw _iteratorError11;
          case 28:
            return _context12.finish(25);
          case 29:
            return _context12.finish(20);
          case 30:
            _context12.next = 32;
            return _awaitAsyncGenerator(cb(last));
          case 32:
            return _context12.abrupt("return", _context12.sent);
          case 33:
          case "end":
            return _context12.stop();
        }
      }, _callee12, null, [[2, 16, 20, 30], [21,, 25, 29]]);
    }));
    return function (_x10) {
      return _ref8.apply(this, arguments);
    };
  }();
};
var lifo = function lifo() {
  var data = [];
  var resolve;
  return {
    "in": function _in(value) {
      if (resolve) {
        resolve(value);
        resolve = undefined;
      } else {
        data.push(value);
      }
      return Promise.resolve(true);
    },
    //@ts-ignore
    out: function () {
      var _ref9 = _wrapAsyncGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee13() {
        return _regeneratorRuntime().wrap(function _callee13$(_context13) {
          while (1) switch (_context13.prev = _context13.next) {
            case 0:
              if (!(data.length > 0)) {
                _context13.next = 6;
                break;
              }
              _context13.next = 4;
              return data.shift();
            case 4:
              _context13.next = 10;
              break;
            case 6:
              _context13.next = 8;
              return _awaitAsyncGenerator(new Promise(function (r) {
                return resolve = r;
              }));
            case 8:
              _context13.next = 10;
              return _context13.sent;
            case 10:
              _context13.next = 0;
              break;
            case 12:
            case "end":
              return _context13.stop();
          }
        }, _callee13);
      }));
      return function out() {
        return _ref9.apply(this, arguments);
      };
    }(),
    flush: function () {
      var _ref10 = _wrapAsyncGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee14() {
        return _regeneratorRuntime().wrap(function _callee14$(_context14) {
          while (1) switch (_context14.prev = _context14.next) {
            case 0:
              if (!data.length) {
                _context14.next = 5;
                break;
              }
              _context14.next = 3;
              return data.shift();
            case 3:
              _context14.next = 0;
              break;
            case 5:
            case "end":
              return _context14.stop();
          }
        }, _callee14);
      }));
      return function flush() {
        return _ref10.apply(this, arguments);
      };
    }()
  };
};
var fifo = function fifo() {
  var data = [];
  var resolve;
  return {
    "in": function _in(value) {
      if (resolve) {
        resolve(value);
        resolve = undefined;
      } else {
        data.push(value);
      }
      return Promise.resolve(true);
    },
    //@ts-ignore
    out: function () {
      var _ref11 = _wrapAsyncGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee15() {
        return _regeneratorRuntime().wrap(function _callee15$(_context15) {
          while (1) switch (_context15.prev = _context15.next) {
            case 0:
              if (!(data.length > 0)) {
                _context15.next = 6;
                break;
              }
              _context15.next = 4;
              return data.pop();
            case 4:
              _context15.next = 10;
              break;
            case 6:
              _context15.next = 8;
              return _awaitAsyncGenerator(new Promise(function (r) {
                return resolve = r;
              }));
            case 8:
              _context15.next = 10;
              return _context15.sent;
            case 10:
              _context15.next = 0;
              break;
            case 12:
            case "end":
              return _context15.stop();
          }
        }, _callee15);
      }));
      return function out() {
        return _ref11.apply(this, arguments);
      };
    }(),
    flush: function () {
      var _ref12 = _wrapAsyncGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee16() {
        return _regeneratorRuntime().wrap(function _callee16$(_context16) {
          while (1) switch (_context16.prev = _context16.next) {
            case 0:
              if (!data.length) {
                _context16.next = 5;
                break;
              }
              _context16.next = 3;
              return data.pop();
            case 3:
              _context16.next = 0;
              break;
            case 5:
            case "end":
              return _context16.stop();
          }
        }, _callee16);
      }));
      return function flush() {
        return _ref12.apply(this, arguments);
      };
    }()
  };
};
var buffer = function buffer(store) {
  return function (bindBuffer) {
    bindBuffer(store["in"]);
    return store.out();
  };
};
var bufferFifo = /*#__PURE__*/buffer( /*#__PURE__*/fifo());
var bufferLifo = /*#__PURE__*/buffer( /*#__PURE__*/lifo());
var by = function by(selector) {
  return /*#__PURE__*/function () {
    var _ref13 = _wrapAsyncGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee17(iterator) {
      var streams, _iteratorAbruptCompletion12, _didIteratorError12, _iteratorError12, _iterator12, _step12, msg, name;
      return _regeneratorRuntime().wrap(function _callee17$(_context17) {
        while (1) switch (_context17.prev = _context17.next) {
          case 0:
            streams = {};
            _iteratorAbruptCompletion12 = false;
            _didIteratorError12 = false;
            _context17.prev = 3;
            _iterator12 = _asyncIterator(iterator);
          case 5:
            _context17.next = 7;
            return _awaitAsyncGenerator(_iterator12.next());
          case 7:
            if (!(_iteratorAbruptCompletion12 = !(_step12 = _context17.sent).done)) {
              _context17.next = 17;
              break;
            }
            msg = _step12.value;
            name = selector(msg);
            if (!streams[name]) {
              streams[name] = lifo();
            }
            streams[name]["in"](msg);
            _context17.next = 14;
            return streams[name].out();
          case 14:
            _iteratorAbruptCompletion12 = false;
            _context17.next = 5;
            break;
          case 17:
            _context17.next = 23;
            break;
          case 19:
            _context17.prev = 19;
            _context17.t0 = _context17["catch"](3);
            _didIteratorError12 = true;
            _iteratorError12 = _context17.t0;
          case 23:
            _context17.prev = 23;
            _context17.prev = 24;
            if (!(_iteratorAbruptCompletion12 && _iterator12["return"] != null)) {
              _context17.next = 28;
              break;
            }
            _context17.next = 28;
            return _awaitAsyncGenerator(_iterator12["return"]());
          case 28:
            _context17.prev = 28;
            if (!_didIteratorError12) {
              _context17.next = 31;
              break;
            }
            throw _iteratorError12;
          case 31:
            return _context17.finish(28);
          case 32:
            return _context17.finish(23);
          case 33:
          case "end":
            return _context17.stop();
        }
      }, _callee17, null, [[3, 19, 23, 33], [24,, 28, 32]]);
    }));
    return function (_x11) {
      return _ref13.apply(this, arguments);
    };
  }();
};
var split = function split(selector, iteratorCallback) {
  return /*#__PURE__*/function () {
    var _ref14 = _wrapAsyncGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee18(iterator) {
      var streams, _iteratorAbruptCompletion13, _didIteratorError13, _iteratorError13, _iterator13, _step13, msg, name;
      return _regeneratorRuntime().wrap(function _callee18$(_context18) {
        while (1) switch (_context18.prev = _context18.next) {
          case 0:
            streams = {};
            _iteratorAbruptCompletion13 = false;
            _didIteratorError13 = false;
            _context18.prev = 3;
            _iterator13 = _asyncIterator(iterator);
          case 5:
            _context18.next = 7;
            return _awaitAsyncGenerator(_iterator13.next());
          case 7:
            if (!(_iteratorAbruptCompletion13 = !(_step13 = _context18.sent).done)) {
              _context18.next = 14;
              break;
            }
            msg = _step13.value;
            name = selector(msg);
            if (!streams[name]) {
              streams[name] = iteratorCallback(name);
            }
          case 11:
            _iteratorAbruptCompletion13 = false;
            _context18.next = 5;
            break;
          case 14:
            _context18.next = 20;
            break;
          case 16:
            _context18.prev = 16;
            _context18.t0 = _context18["catch"](3);
            _didIteratorError13 = true;
            _iteratorError13 = _context18.t0;
          case 20:
            _context18.prev = 20;
            _context18.prev = 21;
            if (!(_iteratorAbruptCompletion13 && _iterator13["return"] != null)) {
              _context18.next = 25;
              break;
            }
            _context18.next = 25;
            return _awaitAsyncGenerator(_iterator13["return"]());
          case 25:
            _context18.prev = 25;
            if (!_didIteratorError13) {
              _context18.next = 28;
              break;
            }
            throw _iteratorError13;
          case 28:
            return _context18.finish(25);
          case 29:
            return _context18.finish(20);
          case 30:
          case "end":
            return _context18.stop();
        }
      }, _callee18, null, [[3, 16, 20, 30], [21,, 25, 29]]);
    }));
    return function (_x12) {
      return _ref14.apply(this, arguments);
    };
  }();
};
var collect = /*#__PURE__*/function () {
  var _ref15 = /*#__PURE__*/_wrapAsyncGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee20(metaIterator) {
    var drain, buf, _iteratorAbruptCompletion14, _didIteratorError14, _iteratorError14, _iterator14, _step14, iterator;
    return _regeneratorRuntime().wrap(function _callee20$(_context20) {
      while (1) switch (_context20.prev = _context20.next) {
        case 0:
          drain = /*#__PURE__*/function () {
            var _ref19 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee19(buffer, iterator) {
              var _iteratorAbruptCompletion15, _didIteratorError15, _iteratorError15, _iterator15, _step15, msg;
              return _regeneratorRuntime().wrap(function _callee19$(_context19) {
                while (1) switch (_context19.prev = _context19.next) {
                  case 0:
                    _iteratorAbruptCompletion15 = false;
                    _didIteratorError15 = false;
                    _context19.prev = 2;
                    _iterator15 = _asyncIterator(iterator);
                  case 4:
                    _context19.next = 6;
                    return _iterator15.next();
                  case 6:
                    if (!(_iteratorAbruptCompletion15 = !(_step15 = _context19.sent).done)) {
                      _context19.next = 12;
                      break;
                    }
                    msg = _step15.value;
                    buffer["in"](msg);
                  case 9:
                    _iteratorAbruptCompletion15 = false;
                    _context19.next = 4;
                    break;
                  case 12:
                    _context19.next = 18;
                    break;
                  case 14:
                    _context19.prev = 14;
                    _context19.t0 = _context19["catch"](2);
                    _didIteratorError15 = true;
                    _iteratorError15 = _context19.t0;
                  case 18:
                    _context19.prev = 18;
                    _context19.prev = 19;
                    if (!(_iteratorAbruptCompletion15 && _iterator15["return"] != null)) {
                      _context19.next = 23;
                      break;
                    }
                    _context19.next = 23;
                    return _iterator15["return"]();
                  case 23:
                    _context19.prev = 23;
                    if (!_didIteratorError15) {
                      _context19.next = 26;
                      break;
                    }
                    throw _iteratorError15;
                  case 26:
                    return _context19.finish(23);
                  case 27:
                    return _context19.finish(18);
                  case 28:
                  case "end":
                    return _context19.stop();
                }
              }, _callee19, null, [[2, 14, 18, 28], [19,, 23, 27]]);
            }));
            return function drain(_x17, _x18) {
              return _ref19.apply(this, arguments);
            };
          }();
          buf = lifo();
          _iteratorAbruptCompletion14 = false;
          _didIteratorError14 = false;
          _context20.prev = 4;
          _iterator14 = _asyncIterator(metaIterator);
        case 6:
          _context20.next = 8;
          return _awaitAsyncGenerator(_iterator14.next());
        case 8:
          if (!(_iteratorAbruptCompletion14 = !(_step14 = _context20.sent).done)) {
            _context20.next = 14;
            break;
          }
          iterator = _step14.value;
          drain(buf, iterator);
        case 11:
          _iteratorAbruptCompletion14 = false;
          _context20.next = 6;
          break;
        case 14:
          _context20.next = 20;
          break;
        case 16:
          _context20.prev = 16;
          _context20.t0 = _context20["catch"](4);
          _didIteratorError14 = true;
          _iteratorError14 = _context20.t0;
        case 20:
          _context20.prev = 20;
          _context20.prev = 21;
          if (!(_iteratorAbruptCompletion14 && _iterator14["return"] != null)) {
            _context20.next = 25;
            break;
          }
          _context20.next = 25;
          return _awaitAsyncGenerator(_iterator14["return"]());
        case 25:
          _context20.prev = 25;
          if (!_didIteratorError14) {
            _context20.next = 28;
            break;
          }
          throw _iteratorError14;
        case 28:
          return _context20.finish(25);
        case 29:
          return _context20.finish(20);
        case 30:
          return _context20.abrupt("return", buf.out());
        case 31:
        case "end":
          return _context20.stop();
      }
    }, _callee20, null, [[4, 16, 20, 30], [21,, 25, 29]]);
  }));
  return function collect(_x13) {
    return _ref15.apply(this, arguments);
  };
}();

var generator = {
  __proto__: null,
  buffer: buffer,
  bufferFifo: bufferFifo,
  bufferLifo: bufferLifo,
  by: by,
  catchLast: catchLast,
  collect: collect,
  cpipe: cpipe,
  delay: delay,
  fifo: fifo,
  filter: filter,
  lifo: lifo,
  limit: limit,
  map: map,
  pipe: pipe,
  probe: probe,
  pull: pull,
  pullAll: pullAll,
  pullArray: pullArray,
  pullCount: pullCount,
  sequence: sequence,
  skip: skip,
  slice: slice,
  split: split,
  window: window
};

/*
 * config system allows us to load configuration from multiple pluggable sources (ConfigLoader functions)
 * and merge them together into a single config object.
 *
 * the config system is designed to be used in a layered way, where each layer can be overriden by the next layer.
 *
 * */
// possible execution environments, this could be overriden by the host app
var Env;
(function (Env) {
  Env["Production"] = "production";
  Env["Development"] = "development";
  Env["Testing"] = "test";
})(Env || (Env = {}));
// merges arrays of deep objects into a single deep object
var mergeByPriority = function mergeByPriority(configArray) {
  return deepMerge.apply(void 0, configArray);
};

var jsonFile = function jsonFile(path, verbose) {
  if (verbose === void 0) {
    verbose = false;
  }
  return new Promise(function (resolve, _) {
    if (verbose) {
      console.log('load JSON', path);
    }
    fs.readFile(path, function (err, buffer) {
      if (err) {
        return resolve({});
      }
      try {
        var parsed = JSON.parse(buffer.toString('utf8'));
        resolve(parsed || {});
      } catch (parseErr) {
        console.error('parsing error on', path);
        console.error(parseErr);
        process.exit(1);
      }
    });
  });
};

var run = function run(cmd, args) {
  return new Promise(function (resolve, reject) {
    try {
      var proc = child_process.spawn(cmd, args);
      var stdout = '';
      var stderr = '';
      proc.stdout.on('data', function (data) {
        stdout += data.toString();
      });
      proc.stderr.on('data', function (data) {
        stderr += data.toString();
      });
      proc.on('close', function (code) {
        if (code != 0) {
          console.log("ERROR CODE CATCH!@");
          reject(stderr);
        } else {
          resolve(stdout);
        }
      });
    } catch (error) {
      console.log("CATCH!");
      reject(error);
    }
  });
};
var fileExists = function fileExists(filePath) {
  return new Promise(function (resolve, _) {
    fs.stat(filePath, function (err, stats) {
      if (err) {
        return resolve(false);
      }
      return resolve(stats.isFile());
    });
  });
};
var sopsFile = /*#__PURE__*/function () {
  var _ref = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(path, verbose) {
    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          if (verbose === void 0) {
            verbose = false;
          }
          _context.next = 3;
          return fileExists(path);
        case 3:
          if (_context.sent) {
            _context.next = 5;
            break;
          }
          return _context.abrupt("return");
        case 5:
          if (verbose) {
            console.log('decrypt SOPS', path);
          }
          console.log("RUNNY SOPSY");
          return _context.abrupt("return", run('sops', ['-d', path]).then(JSON.parse)["catch"](function (error) {
            console.error("CATCHY!!", error);
            console.error("Continuing init");
            return {};
          }));
        case 8:
        case "end":
          return _context.stop();
      }
    }, _callee);
  }));
  return function sopsFile(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var env = function env(verbose) {
  if (verbose === void 0) {
    verbose = false;
  }
  return lodash.reduce(process.env, function (total, val, key) {
    if (!lodash.startsWith(key, 'cfg_')) {
      return total;
    }
    var path = lodash.tail(key.split('_'));
    var collision = lodash.get(total, path);
    if (collision) {
      console.warn("ENV variable at path \"" + key + "\" defined both as dict and a value");
      if (isDict(collision)) {
        return total;
      }
    }
    var uglyMagic = function uglyMagic(val) {
      if (val === 'true') {
        return true;
      }
      if (val === 'false') {
        return false;
      }
      return val;
    };
    if (verbose) {
      console.log('loading env var', key);
    }
    return lodash.set(total, path, uglyMagic(val));
  }, {});
};

var readDir = function readDir(dirPath) {
  return new Promise(function (resolve, _) {
    if (!fs__namespace.existsSync(dirPath)) {
      return resolve([]);
    }
    if (!fs__namespace.lstatSync(dirPath).isDirectory()) {
      return resolve([]);
    }
    fs__namespace.readdir(dirPath, function (err, items) {
      return err ? resolve([]) : resolve(items);
    });
  });
};
var dir = function dir(parsers) {
  return /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(dirPath, verbose) {
      var loadDir;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            if (verbose === void 0) {
              verbose = false;
            }
            loadDir = function loadDir(dirPath) {
              if (verbose) {
                console.log("dir", dirPath);
              }
              return readDir(dirPath).then(function (fileNames) {
                return Promise.all(mapFilter(function (fileName) {
                  var filePath = path__namespace.join(dirPath, fileName);
                  var stat = fs__namespace.lstatSync(filePath);
                  if (stat.isDirectory()) {
                    return loadDir(filePath);
                  }
                  if (!stat.isFile()) {
                    console.warn(filePath + " is not a file");
                    return undefined;
                  }
                  var parser = parsers.find(function (_ref2) {
                    var matcher = _ref2.matcher;
                    return matcher(filePath);
                  });
                  if (parser) {
                    return parser.loader(filePath, verbose);
                  }
                  return undefined;
                })(fileNames.sort().reverse()));
              }).then(mergeByPriority);
            };
            return _context.abrupt("return", loadDir(dirPath));
          case 3:
          case "end":
            return _context.stop();
        }
      }, _callee);
    }));
    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();
};
var jsonRegex = /*#__PURE__*/new RegExp('^.+\.json$');
var jsonSopsRegex = /*#__PURE__*/new RegExp('^.+\.sops\.json$');
var standardDir = /*#__PURE__*/dir([{
  name: 'json',
  loader: jsonFile,
  matcher: function matcher(path) {
    return !Boolean(path.match(jsonSopsRegex)) && Boolean(path.match(jsonRegex));
  }
}, {
  name: 'sopsJson',
  loader: sopsFile,
  matcher: function matcher(path) {
    return Boolean(path.match(jsonSopsRegex));
  }
}]);

//export * from './argv'

var index$1 = {
  __proto__: null,
  dir: dir,
  env: env,
  jsonFile: jsonFile,
  jsonRegex: jsonRegex,
  jsonSopsRegex: jsonSopsRegex,
  sopsFile: sopsFile,
  standardDir: standardDir
};

// Code
// ==========================
// converts deep ConfigConfig into AppConfig
// just runs configLeafLoad via async deep depth first map
var configEval = /*#__PURE__*/function () {
  var _ref = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(configConfig) {
    var result, _i, _Object$entries, _Object$entries$_i, key, val;
    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          if (!lodash.isArray(configConfig)) {
            _context.next = 6;
            break;
          }
          _context.t0 = mergeByPriority;
          _context.next = 4;
          return Promise.all(lodash.map(configConfig, configEval));
        case 4:
          _context.t1 = _context.sent.reverse();
          return _context.abrupt("return", (0, _context.t0)(_context.t1));
        case 6:
          if (!isDict(configConfig)) {
            _context.next = 18;
            break;
          }
          result = {};
          _i = 0, _Object$entries = Object.entries(configConfig);
        case 9:
          if (!(_i < _Object$entries.length)) {
            _context.next = 17;
            break;
          }
          _Object$entries$_i = _Object$entries[_i], key = _Object$entries$_i[0], val = _Object$entries$_i[1];
          _context.next = 13;
          return isDict(val) ? configEval(val) : val;
        case 13:
          result[key] = _context.sent;
        case 14:
          _i++;
          _context.next = 9;
          break;
        case 17:
          return _context.abrupt("return", result);
        case 18:
          return _context.abrupt("return", configConfig);
        case 19:
        case "end":
          return _context.stop();
      }
    }, _callee);
  }));
  return function configEval(_x) {
    return _ref.apply(this, arguments);
  };
}();
var censoredKeys = ['cert', 'connection', 'password', 'pass', 'key', 'token', 'secret'];
var shouldCensor = function shouldCensor(key) {
  return Boolean(lodash.find(censoredKeys, function (substring) {
    return key.toLowerCase().indexOf(substring) !== -1;
  }));
};
var censorConfig = /*#__PURE__*/depthFirstMap(function (value, key) {
  return shouldCensor(key) ? '░░░░░░░░░░░░░░░░' : value;
});
var hardcodedDefaults = {
  censorSecrets: true,
  env: Env.Development,
  rootDir: /*#__PURE__*/path__namespace.join(__dirname, '../../../')
};
var getEnv = function getEnv() {
  switch (process.env. /* treeshake disable */NODE_ENV && process.env.NODE_ENV.toLowerCase()) {
    case 'development':
      return Env.Development;
    case 'testing':
      return Env.Testing;
    case 'test':
      return Env.Testing;
    case 'prod':
      return Env.Production;
    case 'production':
      return Env.Production;
    default:
      console.warn("ENV environment variable set to unknown value, defaulting to development");
      return Env.Development;
  }
};
// TODO: this should always run only once.
// Create a caching loadConfig function, via caching promise wrapper util function
var loadConfig = /*#__PURE__*/function () {
  var _ref2 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(argOpts) {
    var defaultOpts, opts, verbose, loadedConfig, ajv, schema, validate;
    return _regeneratorRuntime().wrap(function _callee2$(_context2) {
      while (1) switch (_context2.prev = _context2.next) {
        case 0:
          defaultOpts = {
            defaultConfig: {},
            configDir: path__namespace.join(__dirname, '../../../config'),
            verbose: true,
            env: getEnv()
          };
          opts = mergeByPriority([defaultOpts, argOpts]);
          opts.defaultConfig.env = opts.env;
          verbose = opts.verbose;
          if (verbose) {
            console.log('env:', opts.env);
            console.log('configdir:', opts.configDir, '\n');
          }
          _context2.next = 7;
          return configEval([env(verbose), sopsFile(path__namespace.join(opts.configDir, opts.env + '.sops.json'), verbose), standardDir(path__namespace.join(opts.configDir, opts.env), verbose), jsonFile(path__namespace.join(opts.configDir, opts.env + '.json'), verbose), jsonFile(path__namespace.join(opts.configDir, 'shared.json'), verbose), sopsFile(path__namespace.join(opts.configDir, 'shared.sops.json'), verbose), standardDir(path__namespace.join(opts.configDir, 'shared'), verbose), opts.defaultConfig, hardcodedDefaults]);
        case 7:
          loadedConfig = _context2.sent;
          if (verbose) {
            console.log('\n' + util__namespace.inspect(loadedConfig.censorSecrets ? censorConfig(loadedConfig) : loadedConfig, {
              depth: 8,
              colors: true
            }) + '\n');
          }
          if (opts.schema) {
            ajv = new Ajv();
            schema = opts.schema;
            validate = ajv.compile(_extends({
              type: 'object',
              additionalProperties: false
            }, schema, {
              properties: _extends({
                censorSecrets: {
                  type: 'boolean'
                },
                env: {
                  "enum": ['test', 'development', 'production']
                },
                rootDir: {
                  type: 'string'
                }
              }, schema.properties),
              required: ['env', 'censorSecrets', 'rootDir'].concat(schema.required ? schema.required : [])
            }));
            if (!validate(loadedConfig)) {
              console.error('config schema validation failed');
              console.error(validate.errors);
              process.exit(100);
            } else if (verbose) {
              console.log('config schema ok');
            }
          }
          return _context2.abrupt("return", loadedConfig);
        case 11:
        case "end":
          return _context2.stop();
      }
    }, _callee2);
  }));
  return function loadConfig(_x2) {
    return _ref2.apply(this, arguments);
  };
}();
var loadConfigCached = function loadConfigCached(args) {
  // @ts-ignore
  return loadConfig(args);
};

var index = {
  __proto__: null,
  get Env () { return Env; },
  configEval: configEval,
  loadConfig: loadConfig,
  loadConfigCached: loadConfigCached,
  loader: index$1,
  mergeByPriority: mergeByPriority
};

var _excluded = ["name"];
var init = function init(_ref) {
  var configSystemArgs = _objectWithoutPropertiesLoose(_ref, _excluded);
  return loadConfig(configSystemArgs).then(function (config) {
    return {
      logger: init$1({
        name: config.name,
        env: config.env,
        transports: config.logger ? config.logger : {
          console: {
            enabled: true
          }
        }
      }),
      config: config
    };
  });
};

var appCore = {
  __proto__: null,
  init: init
};

exports.appCore = appCore;
exports.configSystem = index;
exports.generator = generator;
exports.logger = logger;
exports.types = types;
exports.utils = index$2;
exports.wrap = wrap;
//# sourceMappingURL=lsh-foundation.cjs.development.js.map
