import Ajv from 'ajv';
declare const ajv: Ajv;
import * as promise from './promise';
import * as set from './set';
import * as types from '../types';
export { promise, set, ajv };
type Callback = (value: any, key: string) => any;
export declare const joinPath: (...args: Array<string | Array<string>>) => string;
export declare const fpMapValuesWithKey: any;
export declare const depthFirstMap: (callback: Callback) => any;
export declare function mutableDeepMergeTwo<T>(dict1: types.Dict<T>, dict2: types.Dict<T>): types.Dict<T>;
export declare function mutableDeepMerge<T>(dict: types.Dict<T>, ...dicts: types.Dict<T>[]): types.Dict<T>;
export declare function deepMerge(...dicts: types.Dict<any>[]): any;
export declare const push: <T>(array: T[]) => (value: T) => T[];
export declare const mapFilter: <IN, OUT>(callback: (item: IN) => OUT) => any;
type Transformer = (value: any, key: string) => any;
export declare const transform: <T extends {
    [key: string]: any;
}>(attr: string) => (transformer: Transformer) => (obj: T) => T;
export declare function applyMixins(derivedCtor: any, baseCtors: any[]): void;
export declare const propsCall: <T extends object>(props: types.MaybeFunctionProps<T>) => any;
export declare const propsExec: any;
export declare const maybeFunctionCall: <T>(val: types.MaybeFunction<T>) => T;
export declare const exec: <T>(val: types.MaybeAsync<T>) => Promise<T>;
export declare const isString: (x: any) => x is string;
export declare const isNumber: (x: any) => x is number;
export declare const isFunction: (something?: any) => something is Function;
export declare function isArray(v: any): v is Array<any>;
export declare function isDict(v: any): v is types.Dict<any>;
export declare function notExists(value: any): boolean;
export declare function exists(value: any): boolean;
export declare const args: <IN extends types.Dict<any>, OUT>(defaultArguments: IN) => (targetFunction: (opts: IN) => OUT) => (opts: Partial<IN>) => OUT;
export declare class ArgumentValidationError extends Error {
}
export declare const argsSchema: <IN, OUT>(schema: object) => (targetFunction: (args: IN) => OUT) => (args: Partial<IN>) => OUT;
